<?php
/*******************************************************************************
 *                      PHP Paypal IPN DigiSell
 *******************************************************************************
 *      Author:     Vikas Patial
 *      Email:      admin@ngcoders.com
 *      Website:    http://www.ngcoders.com
 *
 *      File:       download.php
 *      Version:    1.0.0
 *      Copyright:  (c) 2007 - Vikas Patial
 *                  You are free to use, distribute, and modify this software 
 *                  under the terms of the GNU General Public License.  See the
 *                  included license.txt file.
 *      
 *******************************************************************************
 *  VERION HISTORY:
 *
 *      v1.0.0 [04.10.2007] - Initial Version
 *
 *******************************************************************************
 *  DESCRIPTION:
 *
 *      NOTE: See www.ngcoders.com for the most recent version of this script 
 *      and its usage.
 *
 *******************************************************************************
*/

/* Global defines */
$time = time();

include('settings.php');

/**
 * Provides encryption service using RC4 encryption scheme.
 * 
 * RC4 encryption is reversible. See
 *
 * @author Xiang Wei Zhuo <weizhuo[at]gmail.com>
 * @version v1.0, last update on Sat Mar 12 15:19:50 EST 2005
 * @package prado.examples.petshop
 */
class RC4Crypt {

	/**
	 * Encrypt the data.
	 * @param string private key.
	 * @param string data to be encrypted.
	 * @return string encrypted string.
	 */
	function encrypt ($pwd, $data)
	{
		$key[] = '';
		$box[] = '';

		$pwd_length = strlen($pwd);
		$data_length = strlen($data);

		for ($i = 0; $i < 256; $i++)
		{
			$key[$i] = ord($pwd[$i % $pwd_length]);
			$box[$i] = $i;
		}

		for ($j = $i = 0; $i < 256; $i++)
		{
			$j = ($j + $box[$i] + $key[$i]) % 256;
			$tmp = $box[$i];
			$box[$i] = $box[$j];
			$box[$j] = $tmp;
		}
		
		$cipher = '';

		for ($a = $j = $i = 0; $i < $data_length; $i++)
		{
			$a = ($a + 1) % 256;
			$j = ($j + $box[$a]) % 256;

			$tmp = $box[$a];
			$box[$a] = $box[$j];
			$box[$j] = $tmp;

			$k = $box[(($box[$a] + $box[$j]) % 256)];
			$cipher .= chr(ord($data[$i]) ^ $k);

		}

		return ($cipher);

	}

	/**
	 * Decrypt the data.
	 * @param string private key.
	 * @param string cipher text (encrypted text).
	 * @return string plain text. 
	 */
	function decrypt ($pwd, $data)
	{		
		return RC4Crypt::encrypt($pwd, ($data));
	}
}


if(!isset($_GET['file']) || empty($_GET['file'])) {
	echo 'Invalid Request';
	return;
}

$data = $_GET['file'];

$id_time = RC4Crypt::decrypt($secret,base64_decode(rawurldecode($data)));

list($product_id,$timestamp) = explode('|',$id_time);

if(!isset($products[$product_id])) {
	echo 'Invalid Request';
	return;
}

if ($timestamp < $time - ($download_life * 60 * 60 )) {
	echo 'Link Expired';
	return;
}

// Read and dump link 

$file_path = $products[$product_id][2];

$path_parts = pathinfo($file_path);

$file_name = $path_parts['basename'];

$file = @fopen($file_path,"rb");
if ($file) {
	
// set headers
header("Pragma: public");
header("Expires: 0");
header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
header("Cache-Control: public");
header("Content-Description: File Transfer");
header("Content-Type: application/force-download");
header("Content-Disposition: attachment; filename=\"$file_name\"");
header("Content-Transfer-Encoding: binary");
header("Content-Length: " . filesize($file_path));

// download
// @readfile($file_path);

  while(!feof($file)) {
    print(fread($file, 1024*8));
    flush();
    if (connection_status()!=0) {
      @fclose($file);
      die();
    }
  }
  @fclose($file);
} else {
	echo 'File Not Found';
}
?>
